% :- module( visits, [visits/2] ).

:- ensure_loaded( '../src/init_lib' ).
% :- ensure_loaded( library(term_in_file_contiguous_counts) ).
:- ensure_loaded( library(spec_in_file_contiguous_counts) ).
:- ensure_loaded( library(kv_transpose) ).
:- ensure_loaded( library(kv_decompose) ).
:- ensure_loaded( library(default_tmp_directory) ).		% /1.
:- ensure_loaded( library(mktemp_in_dir) ).				% /3.
:- ensure_loaded( library(write_list_elem_per_line) ).		% /1.
:- ensure_loaded( library(write_list_elem_per_line_w_period) ).	% /1.
:- ensure_loaded( library(kv_write_k_per_line) ).			% /1.
:- ensure_loaded( library(kv_additive_k_consolidation) ).	% /2.
:- ensure_loaded( library(flatoms) ).					% /2.
% :- ensure_loaded( library(wake_up) ).					% /0.

:- multifile( exec_extension/2 ).
:- dynamic( exec_extension/2 ).

exec_extension( visits, BareFile ) :-
	flatoms( [BareFile,'.stays'], DataFile1 ),
	flatoms( [BareFile,'.visits'], DataFile2 ),
	flatoms( [BareFile,'.mvisits'], DataFile3 ),
	spec_in_file_contiguous_counts( BareFile, Counts ),
	% spec_in_file_contiguous_counts( BareFile, '.', 2, Counts ),
	% spec_in_file_contiguous_counts( BareFile, c, 1, Counts ),
	% kv_decompose( Counts, _CountsKeys, CountsValues ),
	current_output( OldOut ),
	tell( DataFile1 ),
	kv_write_k_per_line( Counts ),
	told,
	!,
	kv_additive_k_consolidation( Counts, Consol ),
	% kv_transpose( Consol, Trans ),
	keysort( Consol, Sort ),
	reverse( Sort, RevSort ),
	tell( DataFile3 ),
	write_list_elem_per_line_w_period( RevSort ), 
	told,
	!,
	kv_decompose( Sort, AdditiveKeys, _Values ),
	% default_tmp_directory( TmpDir ),
	% % mktemp_in_dir( gnuplotdata_XXXXXX, '.', DataFile1 ),
	% % mktemp_in_dir( gnuplotdata_XXXXXX, '.', DataFile2 ),
	% mktemp_in_dir( gnuplotcoms_XXXXXX, '.', GnuComsFile ),
	tell( DataFile2 ),
	write_list_elem_per_line( AdditiveKeys ), 
	told,
	set_output( OldOut ).
	
	/* ,
	flatoms( ['gnuplot -persist \"',GnuComsFile,'\"'], Gplot1 ),
	gnucomfile_w_lines( GnuComsFile, DataFile1 ),
	exec( Gplot1, [null,null,null], _Pid1 ),
	sleep( 3 ),
	gnucomfile_w_lines( GnuComsFile, DataFile2 ),
	exec( Gplot1, [null,null,null], _Pid2 ),
	sleep( 2 ),
	% delete_file( DataFile1 ),
	% delete_file( DataFile2 ),
	delete_file( GnuComsFile ).
	% wake_up.
	*/ 
