:- op( 1200, xfy, :: ).

de_slp( [] ).
de_slp( [PrvH|T] ) :-
	( atom_concat(Pfx,'.slp',PrvH) ->
		H = PrvH, atom_concat( Pfx, '_dslp.pl', Hout )
		;
		atom_concat( PrvH, '.slp', H ),
		atom_concat( PrvH, '_dslp.pl', Hout )
	),
	open( H, read, In ),
	open( Hout, write, Out ),
	write( Out, (pvars(_,_)) ), write( Out, '.'), nl( Out ),
	read_from( In, Term ),
	de_slp_stream( Term, In, Out ),
	close( In ),
	close( Out ),
	de_slp( T ).

de_slp_stream( end_of_file, _In, _Out ) :- !.
de_slp_stream( Term, In, Out ) :-
	read_slp_term_to_clause( Term, Clause ),
	de_slp_clause( Clause, PlClause ),
	portray_clause( Out, PlClause ),
	read_from( In, NxTerm ),
	de_slp_stream( NxTerm, In, Out ).

read_from( In, Term ) :-
	read_term( In, Term, [singletons(Names)] ),
	( Names = [] ->
		true
		;
		slp_clause_to_spec( Term, Spec ),
		write( user_error, 'singleton variables ' ),
		write( user_error, Names ), write( user_error, ' in predicate '),
		write( user_error, Spec ), nl( user_error )
	).

slp_clause_to_spec( Term, Name/Lgth ) :-
	read_slp_term_to_clause( Term, Clause ),
	( Clause = (Head:-_Body) -> true ; Head = Clause ),
	Head =.. [Name|Args],
	length( Args, Lgth ).

read_slp_term_to_clause( Term, Clause ) :-
	( Term = (_:_::Clause) ->
		true 
		;
		( Term = (_::Clause) ->
			true
			;
			Clause = Term 
		)
	).
de_slp_clause( (Head:-Body), (Head:-PlBody) ) :-
	!,
	de_slp_body( Body, PlBody ).
de_slp_clause( Fact, Fact ).

de_slp_body( (A,B), (PlA,PlB) ) :-
	!,
	de_slp_body( A, PlA ),
	de_slp_body( B, PlB ).
de_slp_body( [_H|_T]:Goal, Goal ) :-
	!.
de_slp_body( Goal, Goal ).
