:- ensure_loaded( '../src/init_lib' ).
:- ensure_loaded( library(lists) ).			% is_list/1, append/3.
:- ensure_loaded( library(system) ).			% system/1.
:- ensure_loaded( library(mktemp_in_dir) ).		% /3.
:- ensure_loaded( library(flatoms) ).			% /2.
:- ensure_loaded( library(gnucomfile) ).	% /2.

geps( In ) :-
	( is_list(In) ->
		Args = In
		;
		Args = [In]
	),
	mktemp_in_dir( gnuplotcoms_XXXXXX, '.', GnuComsFile ),
	geps_1( Args, GnuComsFile ).

geps_1( [], _ ).
geps_1( [Source|T], GnuComsFile ) :-
	atom_codes( Source, HCs ),
	append( Stem, [0'.|DataExt], HCs ),
	append( DataExt, ".eps", Exts ),
	append( Stem, [0'_|Exts], ExtStemCs ),
	atom_codes( ExtStem, ExtStemCs ),
	Disp = term('postscript eps'), 
	File = output(ExtStem),
	gnucomfile_w_lines( GnuComsFile, [Disp,File|T], Source ),
	atom_concat( GnuComsFile, '\"', GnuComsFileDQ ),
	atom_concat( 'gnuplot \"', GnuComsFileDQ, Gplot ),
	system( Gplot ), sleep( 1 ), delete_file( GnuComsFile ).
