/* mvisits_to_avg_family_size( File, Sizes ) :-
     File has terms   :    1-c([1-[],4-[1],2-[1],5-[],6-[],3-[1],7-[],8-[3]]).
     Sizes = [I-Avg|]
*/
:- ensure_loaded( '../../src/lib/read_terms.pl' ).     % /2.

mvisits_to_mean_family_size( File, Sizes ) :-
     read_terms( File, Terms ),
     findall( I-Avg, (member(I-c(Bn),Terms),average_family_in_bn(Bn,0,0,Avg)), Sizes ).

average_family_in_bn( [], Sum, Memb, Mean   ) :- 
     Mean is Sum / Memb.
average_family_in_bn( [_-H|T], Sum, Memb, Mean ) :-
     length( H, L ),
     Acc is Sum + L,
     More is Memb + 1,
     average_family_in_bn( T, Acc, More, Mean ).
     


/*
mvisits_to_avg_family_size( File, Sizes ) :-
     open( File, read, In ),
     read_term( In, Term ),
     mvisits_to_avg_family_size_stream( Term, In, Sizes ),
     close( In ).

mvisits_to_avg_family_size_stream( eof, _In, [] ).
mvisits_to_avg_family_size_stream( end_of_file, _In, [] ).
mvisits_to_avg_family_size_stream( Term, _In, [] ) :-
     
     read_term( In, Next ),
     mvisits_to_avg_family_size_stream( end_of_file, _In, [] ).
     */
