:- ensure_loaded( '../../auxil/n_samples' ).
:- ensure_loaded( '../../auxil/eps_n_latex_graph_freqs' ).
:- ensure_loaded( '../auxil/bn_to_eps' ).
:- ensure_loaded( library(ugraphs) ).		% edges/2 add_edges/3, transpose/2,
									% add_vertices/3.

:- ensure_loaded( 'rpdag_to_bn' ). % /2.

test :-
	Stem = rpdag_nsm,
	Slp  = 'rpdag.slp',
	Opts = [ stem(Stem),samples(10000),dot_ith_intervals(10),
	         % precall/1, post/1,
		    call(rpdag([1,2,3,4],RPDAG)-RPDAG),slp(Slp)],
	n_samples( Opts, Tmp, Frqs ),
	From = 'sampled from rpdag generator program',
	bb_put( tex_model, (rpdag_to_tex,Stem-1) ),
	ToLtx = [tabular(false),package(float)],
	eps_n_latex_graph_freqs( Frqs, Stem, From, 1, Slp, Tmp, ToLtx ).

rpdag_to_tex( RPDAG, S, Stem-Ith, Clean ) :-
	number_codes( Ith, IthCs ),
	atom_codes( AtmI, IthCs ),
	atom_concat( AtmI, '.eps', Psfx ),
	atom_concat( '_mod_', Psfx, Mdfx ),
	atom_concat( Stem, Mdfx, Eps ),
	NxI is Ith + 1,
	RPDAG = rpdag(_,Dir,Und),
	edges( Dir, DirEdges ),
	add_edges( Und, DirEdges, Full ),
	transpose( Full, BnLike ),
	Nodes = [1,2,3,4],
	add_vertices( BnLike, Nodes, BnFull ),
	EpsOpts = [delete(false),
	    cline('-Gnodesep=0.1 -Nfontsize=8 -Nwidth=0.3 -Nheight=0.15')],
	bn_to_eps( BnFull, Eps, EpsOpts ),
	write( S, '   \\begin{table}[H]' ), nl( S ),
	write( S, '   \\begin{tabular}{c}' ), nl( S ),
	write( S, '     \\includegraphics*{' ), write( S, Eps ),
	write( S, '}' ), nl( S ),
	write( S, '   \\end{tabular}' ), nl( S ),

	rpdag_to_bn( RPDAG, ExtBn ),
	atom_concat( '_extbn_', Psfx, ExtMdfx ),
	atom_concat( Stem, ExtMdfx, ExtEps ),
	bn_to_eps( ExtBn, ExtEps, EpsOpts ),
	write( S, '   \\begin{tabular}{c}' ), nl( S ),
	write( S, '     \\includegraphics*{' ), write( S, ExtEps ),
	write( S, '}' ), nl( S ),
	write( S, '   \\end{tabular}' ), nl( S ),

	write( S, '   \\begin{tabular}{l}' ), nl( S ),
	Clean = (write( S, '   \\end{tabular}' ), nl( S ), 
	         write( S, '   \\end{table}'), nl( S ) ),
	bb_put( tex_model, (rpdag_to_tex,Stem-NxI) ).
