:- use_module( library(lists) ).
:- use_module( library(ugraphs) ).
:- use_module( library(ordsets) ).

bn( X, Y )  :-
	bn( X, [], Y ).
bn([],_All,[]).
bn([RV|RVs], CandParents, BN) :-         %it's a Bayes net if
	bn(RVs,[RV|CandParents],TailBN),                     %this is and ..
	choose_parents_pre(RV,CandParents,Parents),
	list_to_ord_set(Parents,OrdParents),
	ord_add_element(TailBN,RV-OrdParents,BN).

choose_parents_pre( 6, _CandParents, [3,4] ).
choose_parents_pre( RV, CandParents, Parents ) :-
	RV =\= 6,
	length( CandParents, L ),
	F is L * 2,
	pick( CandParents, F, Parents ).

pick( [H|T], F, Pck ) :- 
	pick( T, F, TPck ),
	pick_this( H, TPck, Pck ).
pick( [], _, [] ).

pick_this( El, List, [El|List] ) .
pick_this( _El, List, List ).
