:- ensure_loaded( '../../src/init_lib' ).
:- ensure_loaded( library(lists) ).		% nth/3.
:- ensure_loaded( library(charsio) ).		%.
:- ensure_loaded( '../src/display_model' ).
:- ensure_loaded( '../bcw/bcw_data' ).

gvz_nth_fterm( [File,PrvFrom|T] ) :-
	bcw_data( _, _ ),
	to_number( PrvFrom, From ),
	( T = [PrvFor] ->
		to_number( PrvFor, For )
		;
		For = 1
	),
	From > 0,
	open( File, read, In ), 
	gvz_nth_fterm_on_stream( From, For, In ),
	close( In ).

to_number( Prv, Number ) :-
	( atom(Prv) -> 
		atom_codes( Prv, PrvCs ),
		number_codes( Number, PrvCs )
		;
		Number = Prv
	).

gvz_nth_fterm_on_stream( 1, For, In ) :-
	!,
	gvx_next_n( For, In ).
gvz_nth_fterm_on_stream( N, For, In ) :-
	read( In, _FTerm ),
	NxN is N - 1,
	gvz_nth_fterm_on_stream( NxN, For, In ).

gvx_next_n( For, In ) :-
	For > 0,
	!,
	read( In, st(Tms,LL,Mis,M) ),
	write_to_chars( vst(Tms):msclf(Mis), Codes ),
	atom_codes( Atm, Codes ),
	display_model( Atm, M, LL ),
	NxFor is For - 1,
	gvx_next_n( NxFor, In ).
gvx_next_n( _, _In ).
