
% :- ensure_loaded( library(system) ).		% working_directory/2.
:- ensure_loaded( library(lists) ).		% append/3, memberchk/2.
:- ensure_loaded( '../../src/init_lib' ).
:- elm( 'carts/auxil/test_classification' ).
:- elm( 'src/model_type_calls' ).            % /1.
% :- ensure_loaded( '../../../carts/auxil/test_classification' ).

% :- requires( basename/2 ).
:- requires( directory_contents/4 ).
:- requires( file_stems_of_files_with_this_ext/3 ).
:- requires( flatoms/2 ).
:- requires( werr/1 ).
:- requires( sys_info/1 ).

mk_predictions :-
	mk_predictions( [] ).

mk_predictions( InOpts ) :-
	mk_predictions_defaults( Defs ),
	append( InOpts, Defs, Opts ),
	% working_directory( Here, Here ),
	% basename( Here, LocDir ),
	% dirname_train_test_index( LocDir, Train, Test ),
	directory_contents( '.', Files, _Dirs, _Oth ),
	file_stems_of_files_with_this_ext( Files, '.fterms', Stems ),
	% file_stems_of_files_with_this_ext( Files, '.mvisits', Stems ),
	% memberchk( upsh(UpshBin), Opts ),
	% predictions_of_stems( Stems, UpshBin ).
     Stems = [Fst|_],
     atom_concat( Fst, '.stats', FstStats ),
     read_terms( FstStats, FstTerms ),
     memberchk( model_type(MdlType), FstTerms ),
     model_type_calls( MdlType ),
     memberchk( data_file(DFile), FstTerms ),
     memberchk( data_call(DCall), FstTerms ),
     % memberchk( data_file(DFile), FstTerms ),
     ( memberchk(test(Test), Opts) -> true; 
          once( cart_data_file_n_call_to_test_file(DFile, DCall, Test) ) 
     ),
     once( cart_data_call_n_file(DCall,DFile,Ids,Pstv) ),
     ( var(Pstv) ->
          ClsfOps = [output(pbc_pn),test(Test),train_ids(Ids)|Stems]
          ;
          ClsfOps = [output(pbc_pn),test(Test),train_ids(Ids),pstv(Pstv)|Stems]
     ),
     test_classification( ClsfOps ).

cart_data_file_n_call_to_test_file( AbsFile, DCall, AbsTest ) :-
     atom_concat( Path, 'idsd_fprs.pl', AbsFile ),
     DCall = idsd_fprs(RelTrain,_,_),
     ( atom_concat(StemTrain,'.pl',RelTrain) -> true; StemTrain = RelTrain),
     atom_concat( StemTrain, '_test.pl', RelTest ),
     atom_concat( Path, RelTest, AbsTest ).

cart_data_call_n_file( idsd_fprs(RelTrain,Ids,_), DFile, Ids, Pstv ) :-
     write( user_error, ensure_loaded( DFile ) ), nl( user_error ),
     ensure_loaded( DFile ),
     ( atom_concat(pk_, _,RelTrain) -> Pstv = 'Active'; true ),
     call( idsd_fprs(RelTrain,ids(Ids,_),_) ).

mk_predictions_defaults( [upsh(none)] ). %  :-
	% ( bb_get(upsh_exec,Upsh) -> true; Upsh=none).

%%% compile( '$HOME/islp/mcmcms/pbl/icml05/auxil/mk_predictions' ).

predictions_of_stems( [], _Train, _Test, _Ubin ).
predictions_of_stems( [H|T], Train, Test, Ubin ) :-
	( Ubin == none -> 
		atom_concat( H, '.mvisits', Hmvis ),
		TcOpts = [train(Train),output(pbc_pn),file(Hmvis),test(Test)],
		write( user_error, test_classification( TcOpts ) ),
		nl( user_error ),
		test_classification( TcOpts )
		;
		bb_get( icml_aux_dir, AuxDir ),
		TcRel = '/../../../carts/auxil/test_classification.pl ',
		atom_concat( AuxDir, TcRel, TcPl ),
		OutpF = ' output=pbc_pn file=',
		atom_concat( H, '.mvisits test=', HmvisTst ),
		flatoms( [Ubin,' ',TcPl,'train=',Train,OutpF,HmvisTst,Test], Upsh ),
		write( user_error, Upsh), nl( user_error ),
		sys_info( Upsh )
	),
	predictions_of_stems( T, Train, Test, Ubin ).
