% :- ensure_loaded( '../../src/init_lib' ).
:- ensure_loaded( library(requires) ).
:- requires( sys_info/1 ).
:- requires( sum_lists/3 ).
:- requires( div_list/3 ).

post_l_and_d( [] ).
post_l_and_d( [H|T] ) :-
	atom_concat( 'gunzip ', H, Gunzip ),
	sys_info( Gunzip ),
	atom_concat( Hstem, '.gz', H ),
	open( Hstem, read, In ),
	read( In, Term ),
	initial_hot_acc( Term, HotAcc ),
	post_l_and_d( Term, 0, 0, HotAcc, HotAcc, 0, In, Lvs, Dpts, I ),
	close( In ),
	div_list( Lvs, I, AvgLvs ),
	write( lvs(AvgLvs) ), nl,
	div_list( Dpts, I, AvgDpts ),
	write( dpts(AvgDpts) ), nl,
	atom_concat( 'gzip ', Hstem, Gzip ),
	sys_info( Gzip ),
	post_l_and_d( T ).

post_l_and_d( end_of_file, CL, CD, HL, HD, Icnt, _In, Lvs, Dpts, I ) :-
	Lvs = [CL|HL],
	Dpts = [CD|HD],
	I is Icnt.
post_l_and_d( LTerm, CLacc, CDacc, HLacc, HDacc, Icnt, In, Lvs, Dpts, I ) :-
	( LTerm = l(CLt,HLt) -> true ; 
		write( user_error, unrecognised_leaves(LTerm) ), nl( user_error ),
		abort ),
	read( In, DTerm ),
	( DTerm = d(CDt,HDt) -> true ; 
		write( user_error, unrecognised_leaves(DTerm) ), nl( user_error ),
		abort ),
	CLnxt is CLacc + CLt,
	sum_lists( HLacc, HLt, HLnxt ),
	CDnxt is CDacc + CDt,
	sum_lists( HDacc, HDt, HDnxt ),
	Inxt is Icnt + 1,
	read( In, NxTerm ),
	post_l_and_d( NxTerm, CLnxt, CDnxt, HLnxt, HDnxt, Inxt, In, Lvs, Dpts, I ).

initial_hot_acc( l(_,HotChs), HotAcc ) :- 
	!,
	initial_hot_acc_1( HotChs, HotAcc ).
initial_hot_acc( Term, _ ) :- 
	write( user_error, uknown_hot_chains_format(Term) ), nl( user_error ),
	abort.

initial_hot_acc_1( [], [] ).
initial_hot_acc_1( [_H|T], [0|TZeros] ) :-
	initial_hot_acc_1( T, TZeros ).
