:- ensure_loaded( matrix_aux ).

% nem_mll( Phi, D1, D0, Alpha, Beta, L ) :-
%
% See file nem/R/mLL.R  in bioconductor package "nem"
%
nem_mll( Phi, LogL ) :-
     %  get the stored values :
     nem_d0( D0 ),
     nem_d1( D1 ),
     nem_paraneter( alpha, Alpha ),
     nem_parameter( beta, Beta ),
     nem_d0_d1_chi_phi( D1Chi, D0Chi, D1Phi, D0Phi ),
     %  do the calculations :
     matrix_copy( Phi, Chi ),
     matrix_apply_expr( Chi, (1-V1), V1 )
     matrix_dims( D0, Dims ),
     %
     %
     matrix_multiplication( D1, Chi, D1Chi ),
     matrix_multiplication( D0, Chi, D0Chi ),
     matrix_multiplication( D1, Phi, D1Phi ),
     matrix_multiplication( D0, Phi, D0Phi ),
     matrix_apply_expr( D1Chi, (Alpha^V2), V2 ),
     matrix_apply_expr( D0Chi, ((1-Alpha)^V3), V3 ),
     matrix_apply_expr( D1Phi, ((1-Beta)^V4), V4 ),
     matrix_apply_expr( D0Phi, (Beta^V4), V4 ),
     % re-cycling D1Chi, which will hold the result of the 3 multiplications.
     matrix_multiplication( D1Chi,  D0Chi ),
     matrix_multiplication( D1Chi,  D1Phi ),
     matrix_multiplication( D1Chi,  D0Phi ),
     % ( parameter( pe, Pe ) -> D1Chi = DiChi * Pe
     matrix_apply_row( D1Chi, log_of_sum, RowLogs ),
     sum_list( RowLogs, LogL ).

log_of_sum( List, Log ) :-
     sum_list( List, Sum ),
     Log is log( Sum, Log ).
