% comparison_data(LossFs,TrueM,DataSize,ModSpace,BStg,RunLgth,Prior,Lkhood,SeedId,StrGoal).

% :- ensure_loaded( '../auxil/include_sc_auxil' ).
% :- ensure_loaded( '../../auxil/create_mvisits' ).

:- ensure_loaded( 'list_of_first_n_nats' ). % 3.
:- ensure_loaded( slp_has ). % 3.

comparison_data( 
				[loss_01,loss_eg_01,loss_ck,loss_ks,loss_naive_edgecount],
				alarm,
				10,
				rm,
				uc,
				25,
				Slp,
				'../bns/src/llhood/lhood_canonical_bdeu_multi_inc.pl',
				% 103, % saemus
				451, % pc266
				% 772, % minotaur
				none,
				% none/include_sc_auxil,
				[],
				bn/[Nats,Ind,PaLess]
						) :-
	Slp = 'slps/step_known_causes.slp',
	slp_has( 'true/alarm.slp', Ind, PaLess ),
 	list_of_first_n_nats( 37, [], Nats ).

% Also need to define, model_id/2, prior_id/2, lhood_id/2.
% These provide shorthands of the respective comparison_data/n entries
% which will appear in the results directories.

model_id( alarm, al ).

prior_id( 'bn_or_pick_unif.slp', ou ).
prior_id( 'stepped.slp', pd ).
prior_id( 'step_known_causes.slp', pk ).

% lhood_id( '../bns/src/llhood/lhood_canonical_uai01.pl', ua ).
lhood_id( '../bns/src/llhood/lhood_canonical_bdeu_multi.pl', md ).
lhood_id( '../bns/src/llhood/lhood_canonical_bdeu_multi_set.pl', st ).
lhood_id( '../bns/src/llhood/lhood_canonical_bdeu_multi_inc.pl', nc ).
lhood_id( '../bns/src/llhood/lhood_canonical_bdeu_multi_spl.pl', lr ).

