% comparison_data(LossFs,TrueM,DataSize,ModSpace,BStg,RunLgth,Prior,Lkhood,SeedId,StrGoal).

% :- ensure_loaded( '../auxil/include_sc_auxil' ).
% :- ensure_loaded( '../../auxil/create_mvisits' ).
:- ensure_loaded( library(ordsets) ).		%.

:- ensure_loaded( 'list_of_first_n_nats' ). % 3.
:- ensure_loaded( true_nodes_have_nof_pa ). % 2.
:- ensure_loaded( '../slps/all_pairwise_independencies' ). % 2.

comparison_data( 
				[loss_01,loss_eg_01,loss_ck,loss_ks,loss_naive_edgecount],
				TrueBase,
				DataPop,
				rm,
				uc,
				25,
				'slps/identity.slp',
				'../bns/src/llhood/lhood_canonical_bdeu_sharp_multi_spl.pl',
				% 103, % saemus
				% 451, % pc266
				772, % minotaur
				none,
				% none/include_sc_auxil,
				XFs,
				bn/[Bn]
						) :-
	member( TrueBase-XFs, [alarm-[],hailfinder-[],insurance-[],parity1-[],parity2-[]] ),
				/* 
				[ 
				 % alarm-[cp_ld('slps/inc_indep.pl'),cp_ld('true/alarm_inc_findpcs.pl')]
				 insurance-[cp_ld('slps/inc_indep.pl'),cp_ld('true/insurance_inc_findpcs.pl')],
				 hailfinder-[cp_ld('true/hailfinder_inc_findpcs.pl')],
				 parity1-[cp_ld('true/parity1_inc_findpcs.pl')],
				 parity2-[cp_ld('true/parity2_inc_findpcs.pl')]
				] ),
				*/
	member( DataPop, [50] ),
	% member( DataPop, [500,1000] ),
	atom_concat( 'true/', TrueBase, DirTrue ),
	atom_concat( DirTrue, '.slp', True ),
	true_nodes_have_nof_pa( True, _NofPaPrs, UnsBn ),
	sort_parents_to_bn( UnsBn, Bn ).
	% all_pairwise_independencies( Bn, Ipcs ),
	% XFs = [cp('slps/ciex.pl','slps/')].
% :- bb_put( compare_cp,

 	% list_of_first_n_nats( NNds, [], Nats ).

sort_parents_to_bn( [], [] ).
sort_parents_to_bn( [H-UnsPa|T], [H-Pa|R] ) :-
	list_to_ord_set( UnsPa, Pa ),
	sort_parents_to_bn( T, R ).

% Also need to define, model_id/2, prior_id/2, lhood_id/2.
% These provide shorthands of the respective comparison_data/n entries
% which will appear in the results directories.

model_id( alarm, al ).
model_id( insurance, sc ).
model_id( hailfinder, hf ).
model_id( parity1, p1 ).
model_id( parity2, p2 ).

% prior_id( 'bn_or_pick_unif.slp', ou ).
% prior_id( 'stepped.slp', pd ).
% prior_id( 'step_known_causes.slp', pk ).
% prior_id( 'step_fixed_known_causes_ind.slp', xk ).
% prior_id( 'obs_indep_and_known_nof_pa_rej.slp', ij ).
prior_id( 'obs_inc_indep_and_known_nof_pa_rej.slp', cj ).
prior_id( 'identity.slp', iy ).

% lhood_id( '../bns/src/llhood/lhood_canonical_uai01.pl', ua ).
% lhood_id( '../bns/src/llhood/lhood_canonical_bdeu_multi.pl', md ).
% lhood_id( '../bns/src/llhood/lhood_canonical_bdeu_multi_set.pl', st ).
% lhood_id( '../bns/src/llhood/lhood_canonical_bdeu_multi_inc.pl', nc ).
lhood_id( '../bns/src/llhood/lhood_canonical_bdeu_multi_spl.pl', lr ).
