% comparison_data(LossFs,TrueM,DataSize,ModSpace,BStg,RunLgth,Prior,Lkhood,SeedId,StrGoal).

% :- ensure_loaded( '../auxil/include_sc_auxil' ).
% :- ensure_loaded( '../../auxil/create_mvisits' ).

:- ensure_loaded( 'list_of_first_n_nats' ). % 3.
% :- ensure_loaded( slp_has ). % 3.
:- ensure_loaded( true_nodes_have_nof_pa ). % 3.

:- ensure_loaded( id_abbrvs ).

comparison_data( 
				[loss_01,loss_eg_01,loss_ck,loss_ks,loss_naive_edgecount],
				TrueBase,
				DataPop,
				rm,
				uc,
				250000,
				'slps/nof_pa_known.slp',
				'../bns/src/llhood/lhood_canonical_bdeu_sharp_multi_spl.pl',
				% 103, % saemus
				451, % pc266
				% 772, % minotaur
				none,
				% none/include_sc_auxil,
				[],
				bn/[Nodes,KnRtCaus,ParIndc]
						) :-
	member( TrueBase-_NNds, 
		[	
			asia-8,alarm-37,insurance-27,hailfinder-56,
			parity1-22,parity2-100
			] ),
	member( DataPop, [500,1000] ),
	atom_concat( 'true/', TrueBase, DirTrue ),
	atom_concat( DirTrue, '.slp', True ),
	true_nodes_have_nof_pa( True, NofPaPrs, _Bn ),
	nof_prs_to_roots_pa_indices_and_nodes( NofPaPrs, Nodes, KnRtCaus, ParIndc ).
	% slp_has( True, Indcs, PaLess ),
 	% list_of_first_n_nats( NNds, [], Nats ).

% Also need to define, model_id/2, prior_id/2, lhood_id/2.
% These provide shorthands of the respective comparison_data/n entries
% which will appear in the results directories.

nof_prs_to_roots_pa_indices_and_nodes( [], [], [], [] ).
nof_prs_to_roots_pa_indices_and_nodes( [Nd+NofPa|T], [Nd|TNds], KnRtCaus, ParIndc ) :-
	( NofPa =:= 0 -> 
		KnRtCaus = [Nd|TKnRt],
		ParIndc = TParIndc
		;
		KnRtCaus = TKnRt,
		ParIndc = [Nd-NofPa|TParIndc]
	),
	nof_prs_to_roots_pa_indices_and_nodes( T, TNds, TKnRt, TParIndc ).
