:- ensure_loaded( '../../auxil/n_samples_tex' ).

bntest0 :-
	n_samples_tex( [slp('../../bns/slps/bn_or_any_6h34.slp'),samples(100),call(pselect([1,2,3,4,5,6,7,8],V,_),V),res(nat),ad_to_slp([load(cn)])]  ).

bntest :-
	n_samples_tex( [slp('../../bns/slps/bn_or_any_6h34.slp'),samples(100),call(bn([1,2,3,4,5,6,7,8],V),V),res(nat),ad_to_slp([load(cn)])]  ), 
	write( sample(Sample) ), nl,
	write( tmp(Tmp) ), nl.

bntest1 :-
	n_samples( [slp('../../bns/slps/bn_or_any_6h34.slp'),samples(100),call(bn([1,2,3,4,5,6,7,8],V)-V),res(nat),ad_to_slp([load(cn)])], Tmp, Sample ), 
	write( sample(Sample) ), nl,
	write( tmp(Tmp) ), nl.

/* 
Create a tex source for N samples drawn independently from an SLP.

  call/2:              Callable and Observable
  col/1:               number of collumns in latex
  dot_ith_intervals/1: number of completion intervals at which a dot will be printed
  gv/1:                boolean, use gv to display .ps file. Default is false
  out/1:               stem of filename for tex and ps output
  precall/1:           a call invoked once, just before the sampling starts
  post/1:              a call invoked once, immediately after the sampling finishes
  samples/1:           number of samples to be drawn
  slp/1:               the SLP to use
  sort/1:              boolean (false), if set sorts the frequencies before drawing the graph
  stem/1:              can be used instead of the combination of slp/1 and tmp/1
  tmp/1:               temporary file to use, for holding transformed SLP when reading-in

*/
