% :- module( skeleton_possibles_to_six_cart, [skeleton_possibles_to_six_cart/8] ).

:- ensure_loaded( library(lists) ).		% select/3, reverse/2.
:- ensure_loaded( library(ordsets) ).		% ord_intersection/4.

/*
compile( skeleton_possibles_to_six_cart ), save_modules( [skeleton_possibles_to_six_cart], skeleton_possibles_to_six_cart  ), halt.
*/

skeleton_possibles_to_six_cart( cart(F,Ch,L,R), D, Ids, Pssbls, FvCart, Lvs/Tls, Acc, Psts/Tps ) :-
	select( f(F,FChs), Pssbls, TPssbls ),
	select( s(Ch,AllLIds,_AllRIds), FChs, NxFChs ),
	!,
	on_empty_list_unify( NxFChs, NxPssbls, TPssbls, [f(F,NxFChs)|TPssbls] ),
	/* replaced by the above.
	( NxFChs = [] ->
		NxPssbls = TPssbls
		;
		NxPssbls = [f(F,NxFChs)|TPssbls]
	),
	*/
	reverse( Acc, ThisPst ),
	Psts = [ThisPst|InLPsts],
	NxD is D + 1,
	ord_intersection( AllLIds, Ids, LIds, RIds ),
	FvCart = cart( F, Ch, Ids, Pssbls, LFv, RFv ),
	skeleton_possibles_to_six_cart( L, NxD, LIds, NxPssbls, LFv, Lvs/TlsL, [l|Acc], InLPsts/TpsL ),
	skeleton_possibles_to_six_cart( R, NxD, RIds, NxPssbls, RFv, TlsL/Tls, [r|Acc], TpsL/Tps ).
skeleton_possibles_to_six_cart( leaf, D, Ids, Pssbls, FvCart, Lvs/Tls, _Acc, Psts/Psts ) :-
	Lvs = [leaf(D,Ids,Pssbls)-FvCart|Tls].

on_empty_list_unify( EmptyOr, Var, Then, _Else ) :-
	EmptyOr == [],
	!,
	Var = Then.
on_empty_list_unify( _NonEmpty, Else, _Then, Else ).
