/*
this is a run in the spirit of Fig. 8 of the paper.
Be warned to change Dir to some filesystem with loads of free space.
To reproduce the likelihood trajectory file for the two experiments, do:
(a)   run the experiment by, starting a prolog (SICStus or Yap) and
      compile( run_pima_fig8 ).
      run_pima_fig8.
      halt.
(b)   cd into out_pima_fig8 in the directory you have chosen and 
      gunzip *.gz
(c)   start a prolog and
      ['<mcmcms_dir>/carts/auxil/lld_stats_for_stem'].
      lld_stats_for_stem( [tr_uc_rm_pima_idsd_a0_95b0_8_i50K__s419,tr_uc_rm_pima_idsd_a0_95b1_i50K__s473] ).
      halt.
(d)   gzip tr_uc_rm_pima_idsd_a0_95b0_8_i50K__s419 tr_uc_rm_pima_idsd_a0_95b1_i50K__s473

The likelihoods for the models in the chain are in *.llhoods
Use gnuplot manually or via <mcmcms_dir>/auxil/gsplay.pl to create
a .eps file from these numbers. Note that to get a scale similar to that
in the paper you need to explicitly set the y-axis end-points.
Due to improvements in the proposal, the graphs produced are not identical
to the ones presented. There is a definite pull away from the best
likelihood region, which is the main argument for including the graphs,
but the inter-prior differences are not as sharp.
*/

:- ensure_loaded( '../../run' ).
:- elm( 'carts/src/lhood' ).            % llhood_w_diff/5, model_llhood/2.
:- elm( 'auxil/create_mvisits' ).       % exec_extension/2.
% :- elm( 'carts/src/split_cart_to_model' ). % /2.
% :- bb_put( to_model, split_cart_to_model(In,Out)/In/Out ).

:- ensure_loaded( 'slps/ids_split_skips' ).
:- elm( 'carts/pima/auxil/denison_best_p171_skl' ). % skeleton/2.
:- elm( 'carts/auxil/skel_disp_full' ).			% decision_cart_to_cart/4.
:- elm( 'carts/auxil/cart_to_precise_data_values_cart' ). % /3.
:- ensure_loaded( 'data/pima' ).

run_pima_fig8 :-
	Dir = '/local/d1p1/nicos/kong/ijcai05/pima/rr_pima_fig8',
	% Dir = out_bcw_fig7_edit,
	Runs = [		runs_file( runs_pima_fig8 ),
				results_dir( Dir ),
				print([24,28,29,31])
		],
	run( Runs ).

% called from each run/n.
bbputs_init_den :- 
	skeleton( denison_best_p171, DenSkel ),
	findall( [A,B,C,D,E,F,G,H]-Kat, data(A,B,C,D,E,F,G,H,Kat), DataPrs ),
	data_pairs_to_skeleton_data( DataPrs, 1, SklData ),
	decision_cart_to_cart( DenSkel, SklData, 0, MidSpCart ),
	Datum = data(_,_,_,_,_,_,_,_,_),
	cart_to_precise_data_values_cart( MidSpCart, Datum, Cart ),
	% display_model( Cart, [title(denison_p171),lhood(-343),balanced(false)] ),
	bb_put( initial_model_given, Cart ).
