% This script reproduces the run 2po (half data)  which is the middle part
% of Fig. 6. Because of the evolution of the software, the results to this
% experiment are similar, rather than identical, to the one in the paper.
% To reproduce the results:
% (a)   
%       run the experiment by, starting a prolog (SICStus or Yap) and
%       compile( run_2po_hd_fig6_middle)
%       run_2po_hd_fig6_middle.
%       halt.
% (b)   
%       cd into uai01_fig6m_2po_hd
%       start a prolog and execute
%       compile( '<mcmcms_top_dir>/bns/auxil/juxta_two_chains' ).
%       juxta_two_chains( 'fig6m_2po_hd_s1_vs_s40.dat' ).
%       halt.
% GIven that you have gnuplot in your $PATH, a plot will automatically appear.
% At any event, the data for the plot will be stored in fig6l_2po_s1_vs_s40.dat
% so the plot can be reproduced. For instance, use
% <mcmcms_top_dir>/bns/auxil/juxta_chains_plot fig6m_2po_hd_s1_vs_s40.dat

:- ensure_loaded( '../../run' ).
:- elm( 'bns/src/llhood/lhood_canonical_uai01' ).
:- elm( 'auxil/create_mvisits' ).

asia_data_half.
data_format(data(_,_,_,_,_,_,_,_)).
possible_values( _, [0,1] ).

run_2po_hd_fig6_middle :-
	% Dir = '/local/d1p1/nicos/uai01_vs40/uai01_fig6m_2po_hd',
	Dir = uai01_fig6m_2po_hd,
	Runs = [
			runs_file( runs_2po_hd_fig6_middle ),
		 	results_dir( Dir ),
			print([24,28,29])
		],
	run( Runs ).
