% This script reproduces the run 3pu which is the middle part of Fig. 8.
% Because of the evolution of the software, the results to this experiment
% differ from the one in the paper.
% To produce the graph :
% (a)   
%       run the experiment by starting a prolog (SICStus or Yap) and
%       compile( run_3pu_fig8_middle )
%       run_3pu_fig8_middle.
%       halt.
% (b)
%       cd into uai01_fig8m_3pu
%       create the counts by 
%       gunzip tr_cd28_rm_asia_data_full_3pu_i500K__s1.gz
%       <mcmcms_top_dir>/bns/auxil/jc_count_parents.perl tr_cd28_rm_asia_data_full_3pu_i500K__s1 > tr_cd28_rm_asia_data_full_3pu_i500K__s1.counts
%       gzip tr_cd28_rm_asia_data_full_3pu_i500K__s1
% (c) 
%       to visualise a cut-off learned model 0.95, you need graphiviz for this,
%       start a prolog and run:
%       compile( '<mcmcms_top_dir>/bns/auxil/disp_cut_off' ).
%       display_cutt_off( [0.95,'tr_cd28_rm_asia_data_full_3pu_i500K__s1.counts'] ).

:- ensure_loaded( '../../run' ).
:- elm( 'bns/src/llhood/lhood_canonical_uai01' ).
:- elm( 'auxil/create_mvisits' ).

asia_data_full.
data_format(data(_,_,_,_,_,_,_,_)).
possible_values( _, [0,1] ).

run_3pu_fig8_middle :-
	% Dir = '/local/d1p1/nicos/uai01/uai01_fig8l_8pu',
	Dir = uai01_fig8m_3pu,
	Runs = [
			runs_file( runs_3pu_fig7_middle ),
		 	results_dir( Dir ),
			id(1),
			print([24,28,29])
		],
	run( Runs ).
