% This is a temporary hack (2005/01/17). This code is taken
% the Sicstus library to enable us to make speed comparisons 
% between Sicstus and Yap. We have changed the if-then-else
% construct since MCMCMS cannt digest it properly.

:- ensure_loaded( library( ugraphs ) ).
:- ensure_loaded( library( lists ) ).		% member/2, reverse/2.
:- ensure_loaded( library( ordsets ) ).		% ord_add_element/3, ord_subtract/3.

%   path(+Vertex, +Graph, -Path)
%   is given a Graph and a Vertex of that Graph, and returns a maximal
%   Path rooted at Vertex, enumerating more Paths on backtracking.

path_pl(Initial, Graph, Path) :-
	path_pl([Initial], [], Graph, Path).

path_pl(Q, Not, Graph, Path) :-
	Q = [Qhead|_],
	neighbors(Qhead, Graph, Neibs),
	ord_subtract(Neibs, Not, Neibs1),
	path_pl_1(Neibs1, Q, Qhead, Not, Graph, Path).

path_pl_1([], Q, _Qhead, _Not, _Graph, Path) :-
	!,
	reverse(Q, Path).
path_pl_1(Neibs1, Q, Qhead, Not, Graph, Path) :-
	ord_add_element(Not, Qhead, Not1),
	member(N, Neibs1),
	path_pl([N|Q], Not1, Graph, Path).

min_path_pl(Initial, Final, Graph, Path, Length) :-
	min_path_pl([[Initial]|Q], Q, [Initial], Final, Graph, Rev),
	reverse(Rev, Path),
	length(Path, N),
	Length is N-1.

min_path_pl(Head0, Tail0, Closed0, Final, Graph, Rev) :-
	Head0 \== Tail0,
	Head0 = [Sofar|Head],
	Sofar = [V|_],
	min_path_pl_1( V, Tail0, Closed0, Final, Graph, Sofar, Head, Rev ).

min_path_pl_1( V, _Tail0, _Closed0, Final,  _Graph, Sofar, _Head, Rev ) :-
	V == Final,
	!,
	Rev = Sofar.
min_path_pl_1( V, Tail0, Closed0, Final, Graph, Sofar, Head,  Rev ) :-
	neighbors(V, Graph, Neibs),
	ord_union(Closed0, Neibs, Closed, Neibs1),
	enqueue_pl(Neibs1, Sofar, Tail0, Tail),
	min_path_pl(Head, Tail, Closed, Final, Graph, Rev).

enqueue_pl([], _, A, A ).
enqueue_pl([A|B], C, D, E) :-
	'C'(D, [A|C], F),
      enqueue_pl(B, C, F, E).
