:- ensure_loaded( library(lists) ).
:- ensure_loaded( jump ).
:- ensure_loaded( bp ).
:- multifile( mcmc_recovery/2 ).
:- dynamic( mcmc_recovery/2 ).

kernel( SGl, I, Bid, P ) :-
	SGl = Prd/Args,
	copy_term( Args, FrArgs ),
	append( FrArgs, [MODiPrv], PlArgs ),
	length( PlArgs, PlLgth ),
	Arity is PlLgth,
	spec_constructs_scall( Prd/Arity, Type, Path, PlArgs, Slp ),
	once( initial_bp_str(Bid,P,Str) ),
	( bb_delete(initial,MODiPrv) -> true ; true ),
	bb_get( msd, Msd ),
	initial_slp( Msd, Slp ),
	( bb_get( to_model, ToMod/MODiPrv/MODi ) ->
		call( ToMod )
		; 
		MODi = MODiPrv
	),
	path_to_btrack_pos( Path, Bid, Sop ),
	length( Sop, Ni ),
	%% reverse( Pos, Sop ),
	% (VorO == op -> BpStr = P ; BpStr = 1-1/2-P), 
	user:dbg( 28, c(MODi) ),
	model_llhood( MODi, LLi ),
	user:dbg( 31, x(c,LLi,Ni,Sop) ),
	!,
	transition( false, Path, SGl/Type, Sop, MODi, Ni, LLi, Bid/Str, 1, [iter(I)] ).

initial_slp( rm, Slp ) :-
	call( slp:Slp ),
	!.
initial_slp( fm, Slp ) :-
	repeat,
	call( slp:Slp ),
	!.

transition( true, _InP, _SGl, _Sop, _BNi, _Ni, _LLi, _Str, _Iter, _Termin ) :-	!.
transition( false, InPath, SGl, Sop, BNi, Ni, LLi, Bid/Str, I, Termin ) :-
	% write( iter(I) ), nl,
	% user:dbg( 25, iter(I) ),
	once( bp_str_to_bp(Bid,Str,Bp) ),
	backtrack_on_nxt( InPath, SGl, Sop, Ni, Bid/Bp, NwPath, BNst, Nth, BCntr ),
	once( update_bp_str(Bid,Str,NxStr) ),
	NxI is I + 1,
	%% ( BNst == '__failure'  ->
	%	% implies that msd is fm (i.e. bb_get(msd,fm) is true ).
	%%	OutPath = InPath, NxNi is Ni,
	%%	NxBNi = BNi, OutSop = Sop,
	%%	NxLL = LLi, % donot use ' is '
	%%	write( user_error, failed_backtracking ), nl( user_error ),
	%%	abrt
		% display_bns_in_iteration( I, BNi, ['algorithm_hit_a_failure_branch'-[]], none, dont_jump )
	%%	;
		% NxIter is I + 1,
		% dbg( 23, nwpath(NwPath) ),
		% replace BN with MOD
		jump( Bid, BNi, BNst, BCntr, I, LLi, LLst, RecA, Jump ),
		% 2004/10/18,  jump( BNi, BNst, BCntr, I, LLi, LLst, RecA, Jump ),
		user:dbg( 24, b(BNst) ),
		user:dbg( 31, x(b,LLst,Nth,RecA) ),
		( Jump==jump ->
			% dbg( 27, jumping ),
			path_to_btrack_pos( NwPath, Bid, OutSop ),
			%% reverse( NwPos, OutSop ),
			length( OutSop, NxNi ),
			OutPath = NwPath, NxLL = LLst, NxBNi = BNst
			; 
			% dbg( 27, not_jumping ),
			OutPath = InPath, NxNi is Ni, NxLL = LLi,
			NxBNi = BNi, OutSop = Sop
		),
	%% ),
	user:dbg( 28, c(NxBNi) ),
	user:dbg( 31, x(c,NxLL,NxNi,OutSop) ),
	( termination( Termin, Jump, I ) ->
		% dbg( 28, c(NxBNi) ),
		% Model = Jump-OutPath
		bb_put( last_model, c(NxBNi) ),
		Fin = true
		;
		% write( nxp(NxP) ), nl,
		Fin = false
	),
	!,
	transition( Fin, OutPath, SGl, OutSop, NxBNi, NxNi, NxLL, Bid/NxStr, NxI, Termin ).

backtrack_on_nxt( InPath, Prd/Args/Type, Sop, LgS, Bid/Bp, NewPath, MODst, Nth, BLCntr ) :-
	( select_btrack_point( Bid, Sop, LgS, Bp, Nth, BCntr ) ->
		( Nth =:= 0 -> 
			true    % let Left be an uninstantiated variable
			;
			split_on_nth( Nth, InPath, Left, _Right )
		),
		% dbg( 28, split_on_nth( Nth, InPath, Left, _Right ) ),
		% Nds = [1,2,3,4,5,6,7,8],
		copy_term( Args, FrArgs ),
		append( FrArgs, [MODstPrv], PlArgs ),
		pred_type_constructs_scall( Type, Prd, Left/_Sin, PrvPath/[], PlArgs, Slp ),
		% Slp =.. [Prd,_Sd,Left/_Sin,PrvPath/[]|PlArgs],
		% write( user_error, bck_slp(Slp) ), nl(user_error),
		( call(slp:Slp) ->
			( bb_get( to_model, ToMod/MODstPrv/MODst ) ->
				call( ToMod )
				; 
				MODst = MODstPrv
			),
			%%%% INVESTIGATE THIS ...
			% nth( Nth, InPath, _Sin/LblCi ),
			% nth_replace_column( Nth, PrvPath, LblCst, NewPath )
			%%% ALTERNATIVELY (FROM KERNEL_OP, 2003-12-02)
			( Nth =:= 0 ->
				% then we are in indpendent MCMC so LblCi and LblCst can remain
				% uninstantiated.
				true
				;
				nth( Nth, InPath, _Sin/LblCi ),
				nth( Nth, PrvPath, _Sou/LblCst )
				%% write( user_error, lci(LblCi)-lcst(LblCst) ), nl( user_error ),
				%% length( InPath, Length ),
				%% write( user_error, nth(Nth)/length(Length) ), nl( user_error )
			),
			backtrack_and_label_contribution( Bid, BCntr, LblCi, LblCst, BLCntr ), 
			NewPath = PrvPath
			%%%
			% nth( Nth, PrvPath, NewPPoint ),
			% nth( Nth, InPath, _Sou/LblCst )
			% 21st May 2001
			% nth( Nth, NewPath, _Sou/LblCst )
			% dbg( 29, successfull_bactracking )
			;
			( bb_get(msd,fm) ->
				MODst = '__failure', BLCntr is 0
				;
				bb_get(msd,Msd),
				werr( [['Unable to generate model under model structure defition: \'',Msd,'\''],[slp_call(Slp)]] ),
				abort
			)
			%% LblCst = f,
			%% NewPath = [], MODst = []
			% dbg( 29, failed_bactracking )
		)
		;
		werr( [['Unable to backtrack. '],[sop(Sop),bid(Bid/Bp)]] ),
		abort
	),
	!.

path_to_btrack_pos( Path, Bid, Pos ) :-
	path_to_btrack_points( Path, 1, PrvPos ),
	once( bid_points_to_pos(Bid,PrvPos,Pos) ).

path_to_btrack_points( [], _Ind, [] ).
path_to_btrack_points( [H|T], Ind, Pos ) :-
	( H=_Id/Prb ->
		Pos = [Ind-Prb|TPos]
		;
		Pos = TPos
	),
	NxInd is Ind + 1,
	path_to_btrack_points( T, NxInd, TPos ).

select_btrack_point( cd, Points, NoBPoints, P, Nth, Cntr ) :-
	!,
	select_ind_btrack_point( P, Points, NoBPoints, Nth ),
	Cntr = 1. % everything cancels out in evaluating jump-alpha 
select_btrack_point( uc, Points, NoBPoints, _P, NthPoint, Cntr ) :-
	!,
	Lim is NoBPoints + 1,
	random( 1, Lim, Nth ),
	nth( Nth, Points, NthPoint-_NPrb ),
	Cntr = 1. % everything cancels out in evaluating jump-alpha 
select_btrack_point( Bid, Points, _Lg, P, Nth, Cntr ) :-
	select_dep_btrack_point( Points, Bid, P, 1, Nth, Cntr ).

% select_ind_btrack_point( _Curr, _NoBPoints, Nth ) :-
	% Nth = 7.
select_ind_btrack_point( Curr, Points, NoBPoints, NthPoint ) :-
	( NoBPoints < Curr -> Nth = NoBPoints ; Nth = Curr ),
	( Nth =:= 0 -> NthPoint = 0 ; nth( Nth, Points, NthPoint-_NPprb) ).

select_dep_btrack_point( [H-HPrb|T], Bid, P, Acc, Nth, Cntr ) :-
	( T == [] ->
		% dbg( 30, controlled_sample_from_last(H) ),
		Nth = H, Cntr = Acc   % check that this is correct for all BPids
		;
		( continue_backtracking(Bid,P,HPrb,HCntr) ->
			NxAcc is Acc * HCntr,
			select_dep_btrack_point( T, Bid, P, NxAcc, Nth, Cntr )
			;
			((Nth = H, Cntr = Acc) ; 
				  select_dep_btrack_point( T, Bid, P, Acc, Nth, Cntr ) ) 
				  % by using Acc we probably say that this was not a real choice point
				  % which seems a reasonable enough statement
		)
	).

% nth_replace_column( Nth, InPath, LblCst, NewPath ) :-
nth_replace_column( Nth, [H|T], LblCst, NewPath ) :-
	( Nth =< 1 -> 
		( H = Sid:LblCst -> 
			NewPath = [Sid|T]
			;
			H = Sid/LblCst,
			NewPath = [H|T]
		)
		;
		NxN is Nth - 1,
		NewPath = [H|NewT],
		nth_replace_column( NxN, T, LblCst, NewT )
	).

split_on_nth( Nth, [H|T], [H|Left], Right ) :-
	Nth > 1,
	!,
	NxNth is Nth - 1,
	split_on_nth( NxNth, T, Left, Right ).
split_on_nth( _Nth, [H|Right], [H], Right ).

spec_constructs_scall( Prd/Arity, Type, Path, PlArgs, Slp ) :-
	( ad_pt:pred_type( Prd/Arity, Type ) ->
		pred_type_constructs_scall( Type, Prd, _, Path/[], PlArgs, Slp )
		;
		write( user_error, 'Unrecognised predicate call to: ' ),
		write( user_error, Prd/Arity ),
		write( user_error, '. Failing...' ), nl( user_error ),
		fail
	).

pred_type_constructs_scall( Type, Prd, First, Second, PlArgs, Slp ) :-
	( Type == s  -> 				% stochastic predicate
		Slp =.. [Prd,First,Second|PlArgs]
		;
		( Type == d ->
			Slp =.. [Prd,First,Second,_Lvars|PlArgs]
			;
			% default, Type = ns
			Slp =.. [Prd,_Id,First,Second|PlArgs]
		)
	).
/*
split_on_nth_or_earlier( Nth, [H|T], [H|Left], Right ) :-
	Nth >= 1,
	NxNth is Nth - 1,
	split_on_nth_or_earlier( NxNth, T, Left, Right ).
split_on_nth_or_earlier( _Nth, Right, [], Right ).
*/

termination( Termin, _Jump, I ) :-
	( memberchk( iter(IterLim), Termin ) ->
		I >= IterLim, user:dbg( 81, ' TERMINATING ... ' )
		;
		user:dbg( 82, iteration(I) ),
		fail
	).
