
:- defines( yap(_), exists_directory/1 ).

:- ensure_loaded( library(system) ).          % file_property/2.
:- requires( basename/2 ).

exists_directory( Dir ) :-
     file_exists( Dir ),
     file_property( Dir, type(directory) ),
     !.
exists_directory( Dir ) :-
     file_exists( Dir ),
     file_property( Dir, type(symlink) ),
     file_property( Dir, linkto(Link) ),
     basename( Dir, Bname ),
     atom_concat( Bdir, Bname, Dir ),
     ( Bdir == '' -> 
          NxtDir = Link
          ;
          atom_concat( Bdir, Link, NxtDir )
     ),
     exists_directory( NxtDir ).
